-- name: Mario's Nightmare 64 
-- description: Mario's Nightmare 64 is a 140 Star Major Romhack created by Apioeus.\n\nThis hack can range from hard to kaizo difficulty.\n\nPorted by BlackJoystick
-- incompatible: romhack

gLevelValues.entryLevel = LEVEL_CASTLE

gBehaviorValues.trajectories.BowlingBallBobTrajectory      = get_trajectory('bob_seg7_metal_ball_path0_RM2C_path')
gBehaviorValues.trajectories.BowlingBallThiLargeTrajectory = get_trajectory('sThiHugeMetalBallTraj_RM2C_path')
gBehaviorValues.trajectories.KoopaBobTrajectory            = get_trajectory('KoopaBoB_path')
gBehaviorValues.trajectories.KoopaThiTrajectory            = get_trajectory('KoopaTHI_path')

gLevelValues.wingCapSequence = 0x31
gLevelValues.vanishCapSequence = 0x32

camera_set_use_course_specific_settings(false)

smlua_audio_utils_replace_sequence(0x01, 0x22, 75, "01_Seq_custom")
smlua_audio_utils_replace_sequence(0x02, 0x25, 75, "02_Seq_custom")
smlua_audio_utils_replace_sequence(0x03, 0x25, 75, "03_Seq_custom")
smlua_audio_utils_replace_sequence(0x04, 0x25, 75, "04_Seq_custom")
smlua_audio_utils_replace_sequence(0x05, 0x25, 75, "05_Seq_custom")
smlua_audio_utils_replace_sequence(0x06, 0x0E, 75, "06_Seq_custom")
smlua_audio_utils_replace_sequence(0x08, 0x23, 75, "08_Seq_custom")
smlua_audio_utils_replace_sequence(0x09, 0x25, 75, "09_Seq_custom")
smlua_audio_utils_replace_sequence(0x0B, 0x14, 75, "0B_Seq_custom")
smlua_audio_utils_replace_sequence(0x0C, 0x25, 75, "0C_Seq_custom")
smlua_audio_utils_replace_sequence(0x0D, 0x11, 75, "0D_Seq_custom")
smlua_audio_utils_replace_sequence(0x0E, 0x11, 75, "0E_Seq_custom")
smlua_audio_utils_replace_sequence(0x0F, 0x18, 75, "0F_Seq_custom")
smlua_audio_utils_replace_sequence(0x10, 0x12, 75, "10_Seq_custom")
smlua_audio_utils_replace_sequence(0x11, 0x0E, 75, "11_Seq_custom")
smlua_audio_utils_replace_sequence(0x12, 0x1A, 75, "12_Seq_custom")
smlua_audio_utils_replace_sequence(0x13, 0x20, 75, "13_Seq_custom")
smlua_audio_utils_replace_sequence(0x14, 0x1A, 75, "14_Seq_custom")
smlua_audio_utils_replace_sequence(0x15, 0x0E, 75, "15_Seq_custom")
smlua_audio_utils_replace_sequence(0x16, 0x1B, 75, "16_Seq_custom")
smlua_audio_utils_replace_sequence(0x17, 0x1A, 75, "17_Seq_custom")
smlua_audio_utils_replace_sequence(0x1B, 0x14, 75, "1B_Seq_custom")
smlua_audio_utils_replace_sequence(0x1C, 0x20, 75, "1C_Seq_custom")
smlua_audio_utils_replace_sequence(0x1D, 0x1E, 75, "1D_Seq_custom")
smlua_audio_utils_replace_sequence(0x1E, 0x1B, 75, "1E_Seq_custom")
smlua_audio_utils_replace_sequence(0x1F, 0x1A, 75, "1F_Seq_custom")
smlua_audio_utils_replace_sequence(0x20, 0x23, 75, "20_Seq_custom")
smlua_audio_utils_replace_sequence(0x21, 0x24, 75, "21_Seq_custom")
smlua_audio_utils_replace_sequence(0x23, 0x21, 75, "23_Seq_custom")
smlua_audio_utils_replace_sequence(0x24, 0x25, 75, "24_Seq_custom")
smlua_audio_utils_replace_sequence(0x25, 0x25, 75, "25_Seq_custom")
smlua_audio_utils_replace_sequence(0x26, 0x25, 75, "26_Seq_custom")
smlua_audio_utils_replace_sequence(0x27, 0x13, 75, "27_Seq_custom")
smlua_audio_utils_replace_sequence(0x28, 0x25, 75, "28_Seq_custom")
smlua_audio_utils_replace_sequence(0x29, 0x25, 75, "29_Seq_custom")
smlua_audio_utils_replace_sequence(0x2A, 0x21, 75, "2A_Seq_custom")
smlua_audio_utils_replace_sequence(0x2B, 0x25, 75, "2B_Seq_custom")
smlua_audio_utils_replace_sequence(0x2C, 0x19, 75, "2C_Seq_custom")
smlua_audio_utils_replace_sequence(0x2D, 0x25, 75, "2D_Seq_custom")
smlua_audio_utils_replace_sequence(0x2E, 0x1A, 75, "2E_Seq_custom")
smlua_audio_utils_replace_sequence(0x2F, 0x25, 75, "2F_Seq_custom")
smlua_audio_utils_replace_sequence(0x30, 0x0E, 75, "30_Seq_custom")
smlua_audio_utils_replace_sequence(0x31, 0x17, 75, "WingCap")
smlua_audio_utils_replace_sequence(0x32, 0x18, 75, "Vanish")

vec3f_set(gLevelValues.starPositions.KoopaBobStarPos, 3030, 4500, -4600)
vec3f_set(gLevelValues.starPositions.KoopaThiStarPos, 7227, -117, 6449)
vec3f_set(gLevelValues.starPositions.KingBobombStarPos, -4201.0, 5060.0, -3882.0)
vec3f_set(gLevelValues.starPositions.KingWhompStarPos, 708.0, -2700.0, 4085.0)
vec3f_set(gLevelValues.starPositions.EyerockStarPos, 5085.0, -5029.0, -3049.0)
vec3f_set(gLevelValues.starPositions.BigBullyStarPos, 3700.0, 600.0, -5500.0)
vec3f_set(gLevelValues.starPositions.ChillBullyStarPos, 130.0, 1600.0, -4335.0)
vec3f_set(gLevelValues.starPositions.BigPiranhasStarPos, 2892.0, -3200.0, 2522.0)
vec3f_set(gLevelValues.starPositions.TuxieMotherStarPos, -715.0, -171.0, 2188.0)
vec3f_set(gLevelValues.starPositions.WigglerStarPos, -1787.0, -5050.0, 3470.0)
vec3f_set(gLevelValues.starPositions.PssSlideStarPos, -547.0, -4600.0, -540.0)
vec3f_set(gLevelValues.starPositions.RacingPenguinStarPos, -7339.0, -5700.0, -6774.0)
vec3f_set(gLevelValues.starPositions.TreasureChestStarPos, -1800.0, -2500.0, -1700.0)
vec3f_set(gLevelValues.starPositions.GhostHuntBooStarPos, -819.0, -2340.0, 326.0)
vec3f_set(gLevelValues.starPositions.KleptoStarPos, -5550.0, 300.0, -930.0)
vec3f_set(gLevelValues.starPositions.MerryGoRoundStarPos, -1600.0, -2100.0, 205.0)
vec3f_set(gLevelValues.starPositions.MrIStarPos, -819.0, -2340.0, 326.0)
vec3f_set(gLevelValues.starPositions.BalconyBooStarPos, 700.0, 3200.0, 1900.0)
vec3f_set(gLevelValues.starPositions.BigBullyTrioStarPos, -2198.0, -6428.0, -3565.0)
